package com.zm.order.tool.server.dao;

import com.zm.order.tool.server.model.OrderAddr;
import com.zm.order.tool.server.query.OrderAddressQuery;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @author penghui
 */
@Repository
public interface OrderAddrDao {

    /**
     * 插入
     *
     * @param record
     * @return
     */
    int insert(OrderAddr record);

    int insertList(List<OrderAddr> list);

    /**
     * 插入
     *
     * @param orderAddrList
     * @return
     */
    int inserts(@Param("orderAddrList") List<OrderAddr> orderAddrList);

    int updateUpdatedAt(@Param("id") Long id, @Param("userId") Long userId);

    int updateAddr(OrderAddr addr);

    int updateAddrInfo(OrderAddr addr);

    /**
     * 根据订单号查询
     *
     * @param orderNo
     * @param userId
     * @return
     */
    OrderAddr selectByOrderNo(@Param("orderNo") String orderNo,
                              @Param("userId") Long userId);

    OrderAddr selectOne(@Param("id") Long id, @Param("userId") Long userId);

    /**
     * 查询地址列表
     * @param query
     * @return
     * Date: 2021/5/31 5:05 下午
     */
    List<OrderAddr> selectList(OrderAddressQuery query);

    int delete(@Param("id") Long id, @Param("userId") Long userId);

    int deleteByOrderNo(@Param("orderNo") String orderNo, @Param("userId") Long userId);

    /**
     *
     * @date 2021/12/28 15:02
     * @param orderNo
     * @param userId
     * @return int
     **/
    int deleteTemp(@Param("orderNo") String orderNo,
                   @Param("userId") Long userId);

    int updateSellerUser(
            @Param("sellerId") Long sellerId,
            @Param("oldUserId") Long oldUserId,
            @Param("newUserId") Long newUserId,
            @Param("orderNo") String orderNo);
}